unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ieopensavedlg, StdCtrls, ieview, imageenview, ExtCtrls, hyieutils;

type
  TRGB24 = record b, g, r: Byte end;
  PRGBArray = ^TRGBArray;
  TRGBArray = Array[0..16384] of TRGB24;

  TfrmSCC = class(TForm)
    pnlMain: TPanel;
    imgView: TImageEnView;
    btnCorrection: TButton;
    btnImage: TButton;
    lblInfo: TLabel;
    odPic: TOpenImageEnDialog;
    procedure btnImageClick(Sender: TObject);
    procedure btnCorrectionClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSCC: TfrmSCC;

implementation

{$R *.dfm}

procedure CorrectColor(Src, Bmp: TIEBitmap);
var
  d, r, g, b, x, y, w, h, z, RFill: Integer;
  r1, g1, b1, r2, g2, b2, dr1, dg1, db1, dr2, dg2, db2: Int64;
  Row: PRGBArray;
  Pixel: TRGB24;
begin
  Row:= Src.ScanLine[0];
  RFill:= Integer(Src.ScanLine[1]) - Integer(Row);

  h:= Src.Height - 1;
  w:= Src.Width - 1;
  z:= Src.Height * Src.Width;
  r1:= 0; g1:= 0; b1:= 0;
  for y:= 0 to h do begin
    for x:= 0 to w do begin
      Pixel:= Row[x];
      r1:= r1 + Pixel.r;
      g1:= g1 + Pixel.g;
      b1:= b1 + Pixel.b;
    end;
    Row:= PRGBArray(Integer(Row) + RFill);
  end;
  r1:= r1 div z;
  g1:= g1 div z;
  b1:= b1 div z;

  Row:= Src.ScanLine[0];
  dr1:= 0; dg1:= 0; db1:= 0;
  for y:= 0 to h do begin
    for x:= 0 to w do begin
      Pixel:= Row[x];
      d:= Pixel.r - r1;
      dr1:= dr1 + (d * d);
      d:= Pixel.g - g1;
      dg1:= dg1 + (d * d);
      d:= Pixel.b - b1;
      db1:= db1 + (d * d);
    end;
    Row:= PRGBArray(Integer(Row) + RFill);
  end;
  if dr1 > 0 then dr1:= Trunc(Sqrt(dr1 / z));
  if dg1 > 0 then dg1:= Trunc(Sqrt(dg1 / z));
  if db1 > 0 then db1:= Trunc(Sqrt(db1 / z));


  // Now the same for Bmp
  Row:= Bmp.ScanLine[0];
  RFill:= Integer(Bmp.ScanLine[1]) - Integer(Row);

  h:= Bmp.Height - 1;
  w:= Bmp.Width - 1;
  z:= Bmp.Height * Bmp.Width;
  r2:= 0; g2:= 0; b2:= 0;
  for y:= 0 to h do begin
    for x:= 0 to w do begin
      Pixel:= Row[x];
      r2:= r2 + Pixel.r;
      g2:= g2 + Pixel.g;
      b2:= b2 + Pixel.b;
    end;
    Row:= PRGBArray(Integer(Row) + RFill);
  end;
  r2:= r2 div z;
  g2:= g2 div z;
  b2:= b2 div z;

  Row:= Bmp.ScanLine[0];
  dr2:= 0; dg2:= 0; db2:= 0;
  for y:= 0 to h do begin
    for x:= 0 to w do begin
      Pixel:= Row[x];
      d:= Pixel.r - r2;
      dr2:= dr2 + (d * d);
      d:= Pixel.g - g2;
      dg2:= dg2 + (d * d);
      d:= Pixel.b - b2;
      db2:= db2 + (d * d);
    end;
    Row:= PRGBArray(Integer(Row) + RFill);
  end;
  if dr2 > 0 then dr2:= Trunc(Sqrt(dr2 / z));
  if dg2 > 0 then dg2:= Trunc(Sqrt(dg2 / z));
  if db2 > 0 then db2:= Trunc(Sqrt(db2 / z));

  //Now we gone use that info...
  Row:= Src.ScanLine[0];
  RFill:= Integer(Src.ScanLine[1]) - Integer(Row);

  h:= Src.Height - 1;
  w:= Src.Width - 1;
  for y:= 0 to h do begin
    for x:= 0 to w do begin
      Pixel:= Row[x];
      r:= Trunc(r2 + (Pixel.r - r1) * dr2 / dr1);
      g:= Trunc(g2 + (Pixel.g - g1) * dg2 / dg1);
      b:= Trunc(b2 + (Pixel.b - b1) * db2 / db1);
      if r < 0 then r:= 0 else if r > 255 then r:= 255;
      if g < 0 then g:= 0 else if g > 255 then g:= 255;
      if b < 0 then b:= 0 else if b > 255 then b:= 255;
      Row[x].r:= r;
      Row[x].g:= g;
      Row[x].b:= b;
    end;
    Row:= PRGBArray(Integer(Row) + RFill);
  end;
end;

procedure TfrmSCC.btnCorrectionClick(Sender: TObject);
var
  bmp: TIEBitmap;
begin
  if odPic.Execute then begin
    bmp:= TIEBitmap.Create;
    bmp.Assign(imgView.IEBitmap);
    imgView.IO.LoadFromFile(odPic.FileName);
    CorrectColor(bmp, imgView.IEBitmap);
    imgView.IEBitmap.Assign(bmp);
    imgView.Refresh;
  end;
end;

procedure TfrmSCC.btnImageClick(Sender: TObject);
begin
  if odPic.Execute then imgView.IO.LoadFromFile(odPic.FileName);
end;

end.
